{******************************************************************************}
{                                                                              }
{       Mecenas Library - Delphi 6                                             }
{       mcLibD6                                                                }
{       Copyright (c) 2000-2002, Ivan Mecenas                                  }
{                                                                              }
{******************************************************************************}

unit mcVCLDatas;

interface

uses
  Classes, DesignIntf, SysUtils, Dialogs, mcDCLLib;

type

{ Componentes }
  TmcDatas = class(TComponent)
  private
    FDataExtensoLonga: String;
    FDataExtensoCurta: String;
    FDiaSemana: String;
    FPrimeiroDiaMes: TDateTime;
    FUltimoDiaMes: TDateTime;
    FData: TDateTime;
    FMes: Word;
    FAno: Word;
    FDia: Word;
    procedure SetAno(const Value: Word);
    procedure SetData(const Value: TDateTime);
    procedure SetDataExtensoCurta(const Value: String);
    procedure SetDataExtensoLonga(const Value: String);
    procedure SetDia(const Value: Word);
    procedure SetDiaSemana(const Value: String);
    procedure SetMes(const Value: Word);
    procedure SetPrimeiroDiaMes(const Value: TDateTime);
    procedure SetUltimoDiaMes(const Value: TDateTime);
  protected
  public
    constructor Create (AOwner: TComponent); override;
  published
    property Data :TDateTime read FData write SetData;
    property Ano :Word read FAno write SetAno;
    property Mes :Word read FMes write SetMes;
    property Dia :Word read FDia write SetDia;
    property DiaSemana :String read FDiaSemana write SetDiaSemana;
    property PrimeiroDiaMes :TDateTime read FPrimeiroDiaMes write SetPrimeiroDiaMes;
    property UltimoDiaMes :TDateTime read FUltimoDiaMes write SetUltimoDiaMes;
    property DataExtensoLonga :String read FDataExtensoLonga write SetDataExtensoLonga;
    property DataExtensoCurta :String read FDataExtensoCurta write SetDataExtensoCurta;
  end;

  TmcFeriados = class(TComponent)
  private
    FDomingoPascoa: TDateTime;
    FQuartaFeiraCinzas: TDateTime;
    FTercaFeiraCarnaval: TDateTime;
    FSextaFeiraSanta: TDateTime;
    FSegundaFeiraCarnaval: TDateTime;
    FCorpusChrist: TDateTime;
    FQuintaFeiraSanta: TDateTime;
    FAno: Word;
    FDiaSemanaCorpusChrist: String;
    procedure SetAno(const Value: Word);
    procedure SetCorpusChrist(const Value: TDateTime);
    procedure SetDomingoPascoa(const Value: TDateTime);
    procedure SetQuartaFeiraCinzas(const Value: TDateTime);
    procedure SetQuintaFeiraSanta(const Value: TDateTime);
    procedure SetSegundaFeiraCarnaval(const Value: TDateTime);
    procedure SetSextaFeiraSanta(const Value: TDateTime);
    procedure SetTercaFeiraCarnaval(const Value: TDateTime);
    procedure SetDiaSemanaCorpusChrist(const Value: String);
  protected
  public
    constructor Create (AOwner: TComponent); override;
  published
    property Ano :Word read FAno write SetAno;
    property DomingoPascoa :TDateTime read FDomingoPascoa write SetDomingoPascoa;
    property QuintaFeiraSanta :TDateTime read FQuintaFeiraSanta write SetQuintaFeiraSanta;
    property SextaFeiraSanta :TDateTime read FSextaFeiraSanta write SetSextaFeiraSanta;
    property CorpusChrist :TDateTime read FCorpusChrist write SetCorpusChrist;
    property DiaSemanaCorpusChrist :String read FDiaSemanaCorpusChrist write SetDiaSemanaCorpusChrist;
    property SegundaFeiraCarnaval :TDateTime read FSegundaFeiraCarnaval write SetSegundaFeiraCarnaval;
    property TercaFeiraCarnaval :TDateTime read FTercaFeiraCarnaval write SetTercaFeiraCarnaval;
    property QuartaFeiraCinzas :TDateTime read FQuartaFeiraCinzas write SetQuartaFeiraCinzas;
  end;

procedure Register;

implementation

{ TmcDatas }

constructor TmcDatas.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FData := Date;
  SetData(FData);
end;

procedure TmcDatas.SetData(const Value: TDateTime);
begin
  FData := Value;
  FAno := mcRetornaAno(FData);
  FMes := mcRetornaMes(FData);
  FDia := mcRetornaDia(FData);
  FDiaSemana := mcDiaSemana(FData);
  FPrimeiroDiaMes := mcPrimeiroDiaMes(FData);
  FUltimoDiaMes := mcUltimoDiaMes(FData);
  FDataExtensoLonga := mcDataExtensoLonga(FData);
  FDataExtensoCurta := mcDataExtensoCurta(FData);
end;

procedure TmcDatas.SetAno(const Value: Word);
begin
  FAno := mcRetornaAno(FData);
end;

procedure TmcDatas.SetDataExtensoCurta(const Value: String);
begin
  FDataExtensoCurta := mcDataExtensoCurta(FData);
end;

procedure TmcDatas.SetDataExtensoLonga(const Value: String);
begin
  FDataExtensoLonga := mcDataExtensoLonga(FData);
end;

procedure TmcDatas.SetDia(const Value: Word);
begin
  FDia := mcRetornaDia(FData);
end;

procedure TmcDatas.SetDiaSemana(const Value: String);
begin
  FDiaSemana := mcDiaSemana(FData);
end;

procedure TmcDatas.SetMes(const Value: Word);
begin
  FMes := mcRetornaMes(FData);
end;

procedure TmcDatas.SetPrimeiroDiaMes(const Value: TDateTime);
begin
  FPrimeiroDiaMes := mcPrimeiroDiaMes(FData);
end;

procedure TmcDatas.SetUltimoDiaMes(const Value: TDateTime);
begin
  FUltimoDiaMes := mcUltimoDiaMes(FData);
end;

{ TmcFeriados }

constructor TmcFeriados.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAno := mcRetornaAno(Date);
  SetAno(FAno);
end;

procedure TmcFeriados.SetAno(const Value: Word);
begin
  if (Value <= 9999) then
    FAno := Value
  else
    FAno := mcRetornaAno(Date);

  FDomingoPascoa := mcFeriadoMovel(FAno,'DOMINGO');
  FQuintaFeiraSanta := mcFeriadoMovel(FAno,'QUINTA');
  FSextaFeiraSanta := mcFeriadoMovel(FAno,'SEXTA');
  FCorpusChrist := mcFeriadoMovel(FAno,'CORPUS');
  FDiaSemanaCorpusChrist := mcDiaSemana(FCorpusChrist);
  FSegundaFeiraCarnaval := mcFeriadoMovel(FAno,'SEGUNDA');
  FTercaFeiraCarnaval := mcFeriadoMovel(FAno,'TERCA');
  FQuartaFeiraCinzas := mcFeriadoMovel(FAno,'QUARTA');
end;

procedure TmcFeriados.SetCorpusChrist(const Value: TDateTime);
begin
  FCorpusChrist := mcFeriadoMovel(FAno,'CORPUS');
end;

procedure TmcFeriados.SetDiaSemanaCorpusChrist(const Value: String);
begin
  FCorpusChrist := mcFeriadoMovel(FAno,'CORPUS');
  FDiaSemanaCorpusChrist := mcDiaSemana(FCorpusChrist);
end;

procedure TmcFeriados.SetDomingoPascoa(const Value: TDateTime);
begin
  FDomingoPascoa := mcFeriadoMovel(FAno,'DOMINGO');
end;

procedure TmcFeriados.SetQuartaFeiraCinzas(const Value: TDateTime);
begin
  FQuartaFeiraCinzas := mcFeriadoMovel(FAno,'QUARTA');
end;

procedure TmcFeriados.SetQuintaFeiraSanta(const Value: TDateTime);
begin
  FQuintaFeiraSanta := mcFeriadoMovel(FAno,'QUINTA');
end;

procedure TmcFeriados.SetSegundaFeiraCarnaval(const Value: TDateTime);
begin
  FSegundaFeiraCarnaval := mcFeriadoMovel(FAno,'SEGUNDA');
end;

procedure TmcFeriados.SetSextaFeiraSanta(const Value: TDateTime);
begin
  FSextaFeiraSanta := mcFeriadoMovel(FAno,'SEXTA');
end;

procedure TmcFeriados.SetTercaFeiraCarnaval(const Value: TDateTime);
begin
  FTercaFeiraCarnaval := mcFeriadoMovel(FAno,'TERCA');
end;

procedure Register;
begin
  RegisterComponents ('mcLibD6',[TmcDatas,TmcFeriados]);

{ TmcDatas }
  RegisterPropertyInCategory('Datas',TmcDatas,'Data');
  RegisterPropertyInCategory('Datas',TmcDatas,'Ano');
  RegisterPropertyInCategory('Datas',TmcDatas,'Mes');
  RegisterPropertyInCategory('Datas',TmcDatas,'Dia');
  RegisterPropertyInCategory('Datas',TmcDatas,'DiaSemana');
  RegisterPropertyInCategory('Datas',TmcDatas,'PrimeiroDiaMes');
  RegisterPropertyInCategory('Datas',TmcDatas,'UltimoDiaMes');
  RegisterPropertyInCategory('Datas',TmcDatas,'DataExtensoLonga');
  RegisterPropertyInCategory('Datas',TmcDatas,'DataExtensoCurta');

{ TmcFeriados }
  RegisterPropertyInCategory('Feriados',TmcFeriados,'Ano');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'DomingoPascoa');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'QuintaFeiraSanta');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'SextaFeiraSanta');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'CorpusChrist');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'DiaSemanaCorpusChrist');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'SegundaFeiraCarnaval');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'TercaFeiraCarnaval');
  RegisterPropertyInCategory('Feriados',TmcFeriados,'QuartaFeiraCinzas');
end;

end.
